/*********************************************************************/
/*                                                                   */
/*   FILE NAME: HAPI_C.H                                             */
/*                                                                   */
/*   MODULE NAME = HAPI_C.H                                          */
/*                                                                   */
/*   DESCRIPTIVE NAME = EHLLAPI VERSION 1.2 INCLUDE FILE FOR "C"     */
/*                                                                   */
/*                                                                   */
/*                                                                   */
/*   STATUS=  RELEASE X, MODIFICATION X.XX                           */
/*                                                                   */
/*   FUNCTION=                                                       */
/*     DEFINE FUNCTION CODES, RETURN CODES, AND STRUCTURES FOR       */
/*     EHLLAPI.                                                      */
/*                                                                   */
/*   CHANGE ACTIVITY=                                                */
/*                                                                   */
/*************************-END OF PROLOG-*****************************/
/*********************************************************************/
/*BEGINPDL(000,001)                                                  */
/*ENDPDL                                                             */
/*BEGINCDE(000,001)                                                  */

/*********************************************************************/
/**************** EHLLAPI FUNCTION NUMBERS ***************************/
/*********************************************************************/

#define HA_CONNECT_PS            1      /* 000 Connect PS            */
                                        /* function number.          */

#define HA_DISCONNECT_PS         2      /* 000 Disconnect PS         */
                                        /* function number.          */

#define HA_SENDKEY               3      /* 000 Sendkey function      */
                                        /* number.                   */

#define HA_WAIT                  4      /* 000 Wait function         */
                                        /* number.                   */

#define HA_COPY_PS               5      /* 000 Copy PS function      */
                                        /* number.                   */

#define HA_SEARCH_PS             6      /* 000 Search PS function    */
                                        /* number.                   */

#define HA_QUERY_CURSOR_LOC      7      /* 000 Query Cursor          */
                                        /* Location function         */
                                        /* number.                   */

#define HA_COPY_PS_TO_STR        8      /* 000 Copy PS to String     */
                                        /* function number.          */

#define HA_SET_SESSION_PARMS     9      /* 000 Set Session           */
                                        /* Parameters function       */
                                        /* number.                   */

#define HA_QUERY_SESSIONS        10     /* 000 Query Sessions        */
                                        /* function number.          */

#define HA_RESERVE               11     /* 000 Reserve function      */
                                        /* number.                   */

#define HA_RELEASE               12     /* 000 Release function      */
                                        /* number.                   */


#define HA_COPY_OIA              13     /* 000 Copy OIA function     */
                                        /* number.                   */

#define HA_QUERY_FIELD_ATTR      14     /* 000 Query Field           */
                                        /* Attribute function        */
                                        /* number.                   */

#define HA_COPY_STR_TO_PS        15     /* 000 Copy string to PS     */
                                        /* function number.          */

#define HA_STORAGE_MGR           17     /* 000 Storage Manager       */
                                        /* function number.          */

#define HA_PAUSE                 18     /* 000 Pause function        */
                                        /* number.                   */

#define HA_QUERY_SYSTEM          20     /* 000 Query System          */
                                        /* function number.          */

#define HA_RESET_SYSTEM          21     /* 000 Reset System          */
                                        /* function number.          */

#define HA_QUERY_SESSION_STATUS  22     /* 000 Query Session         */
                                        /* Status function           */
                                        /* number.                   */

#define HA_START_HOST_NOTIFY     23     /* 000 Start Host            */
                                        /* Notification function     */
                                        /* number.                   */

#define HA_QUERY_HOST_UPDATE     24     /* 000 Query Host Update     */
                                        /* function number.          */

#define HA_STOP_HOST_NOTIFY      25     /* 000 Stop Host             */
                                        /* Notification function     */
                                        /* number.                   */

#define HA_SEARCH_FIELD          30     /* 000 Search Field          */
                                        /* function number.          */

#define HA_FIND_FIELD_POS        31     /* 000 Find Field Length     */
                                        /* function number.          */

#define HA_FIND_FIELD_LEN        32     /* 000 Find Field            */
                                        /* Position function         */
                                        /* number.                   */

#define HA_COPY_STR_TO_FIELD     33     /* 000 Copy String to        */
                                        /* Field function number.    */

#define HA_COPY_FIELD_TO_STR     34     /* 000 Copy Field to         */
                                        /* String function           */
                                        /* number.                   */

#define HA_SET_CURSOR            40     /* 000 Set Cursor            */
                                        /* function number.          */

#define HA_START_CLOSE_INTERCEPT 41     /* 000 Start Close Intercept */
                                        /* function number.          */

#define HA_QUERY_CLOSE_INTERCEPT 42     /* 000 Query Close Intercept */
                                        /* function number.          */

#define HA_STOP_CLOSE_INTERCEPT  43     /* 000 Stop Close Intercept  */
                                        /* function number.          */

#define HA_START_KEY_INTERCEPT   50     /* 000 Start Keystroke       */
                                        /* Intercept function        */
                                        /* number.                   */

#define HA_GET_KEY               51     /* 000 Get Key function      */
                                        /* number.                   */

#define HA_POST_INTERCEPT_STATUS 52     /* 000 Post Intercept        */
                                        /* Status function           */
                                        /* number.                   */

#define HA_STOP_KEY_INTERCEPT    53     /* 000 Stop Keystroke        */
                                        /* Intercept function        */
                                        /* number.                   */

#define HA_SEND_FILE             90     /* 000 Send File function    */
                                        /* number.                   */

#define HA_RECEIVE_FILE          91     /* 000 Receive file          */
                                        /* function number.          */

#define HA_CONVERT_POS_ROW_COL   99     /* 000 Convert Position      */
                                        /* or Row Column function    */
                                        /* number.                   */

#define HA_CONNECT_PM_SRVCS     101     /* 000 Connect For           */
                                        /* Presentation Manager      */
                                        /* Window Services function  */
                                        /* number                    */

#define HA_DISCONNECT_PM_SRVCS  102     /* 000 Disconnect From       */
                                        /* Presentation Manager      */
                                        /* Window Services function  */
                                        /* number                    */

#define HA_QUERY_WINDOW_COORDS  103     /* 000 Query Presentation    */
                                        /* Manager Window            */
                                        /* Coordinates function      */
                                        /* number                    */

#define HA_PM_WINDOW_STATUS     104     /* 000 PM Window Status      */
                                        /* function number           */

#define HA_CHANGE_SWITCH_NAME   105     /* 000 Change Switch List    */
                                        /* Logical Terminal name     */
                                        /* function number           */

#define HA_CHANGE_WINDOW_NAME   106     /* 000 Change PS Window      */
                                        /* Name function number      */

/*********************************************************************/
/******************** EHLLAPI RETURN CODES ***************************/
/*********************************************************************/


#define HARC_SUCCESS               0    /* 000 Good return code.     */

#define HARC99_INVALID_INP         0    /* 000 Incorrect input       */
                                        /* for Convert Position      */
                                        /* or RowCol(99).            */

#define HARC_INVALID_PS            1    /* 000 Invalid PS, Not       */
                                        /* connected return code.    */

#define HARC_BAD_PARM              2    /* 000 Bad parameter, or     */
                                        /* verb not supported        */
                                        /* return code.              */

#define HARC_BUSY                  4    /* 000 PS is busy return     */
                                        /* code.                     */

#define HARC_LOCKED                5    /* 000 PS is LOCKed, or      */
                                        /* invalid keystroke         */
                                        /* return code.              */

#define HARC_TRUNCATION            6    /* 000 Truncation            */
                                        /* occured, or invalid       */
                                        /* length return code.       */

#define HARC_INVALID_PS_POS        7    /* 000 Invalid PS            */
                                        /* position return code.     */

#define HARC_NO_PRIOR_START        8    /* 000 No prior start        */
                                        /* keystroke int. or host    */
                                        /* notify return code.       */

#define HARC_SYSTEM_ERROR          9    /* 000 A system error        */
                                        /* occured return code.      */

#define HARC_UNSUPPORTED           10   /* 000 Invalid or            */
                                        /* unsupported function      */
                                        /* number return code.       */

#define HARC_UNAVAILABLE           11   /* 000 Resource is           */
                                        /* unavalible at this        */
                                        /* time return code.         */

#define HARC_SESSION_STOPPED       12   /* 000 Session has           */
                                        /* been stopped              */

#define HARC_BAD_MNEMONIC          20   /* 000 Illegal mnemonic      */
                                        /* return code.              */

#define HARC_OIA_UPDATE            21   /* 000 A OIA update          */
                                        /* occurred return code.     */

#define HARC_PS_UPDATE             22   /* 000 A PS update           */
                                        /* occurred return code.     */

#define HARC_PS_AND_OIA_UPDATE     23   /* A PS and OIA update       */
                                        /* occurred return code.     */

#define HARC_STR_NOT_FOUND_UNFM_PS 24   /* 000 String not found,     */
                                        /* or Unformated PS          */
                                        /* return code.              */

#define HARC_NO_KEYS_AVAIL         25   /* 000 No keys available     */
                                        /* return code.              */

#define HARC_HOST_UPDATE           26   /* 000 A HOST update         */
                                        /* occurred return code.     */

#define HARC_FIELD_LEN_ZERO        28   /* 000 Field length = 0      */
                                        /* return code.              */

#define HARC_QUEUE_OVERFLOW        31   /* 000 Keystroke queue       */
                                        /* overflow return code.     */

#define HARC99_INVALID_PS        9998   /* 000 An invalid PS id      */
                                        /* was specified, or PS      */
                                        /* was never connected, or   */
                                        /* System Error occured      */
                                        /* for Convert Position      */
                                        /* or RowCol(99).            */

#define HARC99_INVALID_CONV_OPT  9999   /* 000 Invalid convert       */
                                        /* option was specified.     */
                                        /* for Convert Position      */
                                        /* or RowCol(99).            */

/*********************************************************************/
/******************* EHLLAPI FUNCTION STRUCTURES *********************/
/*********************************************************************/


/*********************************************************************/
/*                     Query Sessions (10)                           */
/*********************************************************************/

struct qses_struct                      /* 000 Query Sessions        */
                                        /* structure                 */
{
  unsigned char qses_shortname;         /* 000 Session Shortname     */
  unsigned char qses_longname[8];       /* 000 Session Longname      */
  unsigned char qses_sestype;           /* 000 Session Type          */
  unsigned short int qses_pssize;       /* 000 Presentation Space    */
                                        /* Size.                     */
}
;                                       /* 000                       */



/*********************************************************************/
/*                         Copy OIA (13)                             */
/*********************************************************************/

struct coia_struct                      /* 000 Copy OIA structure    */
{
  unsigned char coia_format;            /* 000 The OIA Format        */
                                        /* Byte for the 3270 PC.     */

  unsigned char coia_image[80];         /* 000 The OIA image         */

  unsigned char coia_group[22];         /* 000 The OIA group         */
}
;                                       /* 000                       */


/*********************************************************************/
/*                     Storage Manager (17)                          */
/*********************************************************************/

struct stor_struct                      /* 000 Storage Manager       */
                                        /* structure.                */
{
  unsigned char far* stor_ptr;          /* 000 4 byte pointer to     */
                                        /* memory.                   */
}
;                                       /* 000                       */



/*********************************************************************/
/*                     Query System (20)                             */
/*********************************************************************/

struct qsys_struct                      /* 000 Query System          */
                                        /* structure                 */
{
  unsigned char qsys_hllapi_ver;        /* 000 Ehllapi version       */
  unsigned char qsys_hllapi_lvl[2];     /* 000 Ehllapi level         */
  unsigned char qsys_hllapi_date[6];    /* 000 Ehllapi release       */
                                        /* date                      */
  unsigned char qsys_lim_ver;           /* 000 LIM version           */
  unsigned char qsys_lim_lvl[2];        /* 000 LIM level             */
  unsigned char qsys_hardware_base;     /* 000 Hardware base         */
  unsigned char qsys_ctrl_prog_type;    /* 000 Control program       */
                                        /* type                      */
  unsigned char qsys_seq_num[2];        /* 000 Sequence number       */
  unsigned char qsys_ctrl_prog_ver[2];  /* 000 Control program       */
                                        /* version                   */
  unsigned char qsys_pc_sname;          /* 000 Base pc session       */
                                        /* name                      */
  unsigned char qsys_err1[4];           /* 000 System error words    */
                                        /* and 2                     */
  unsigned char qsys_err2[4];           /* 000 System error words    */
                                        /* and 4                     */
  unsigned char qsys_sys_model;         /* 000 System model          */
  unsigned char qsys_sys_submodel;      /* 000 System submodel       */
  unsigned short int qsys_pc_nls;       /* 000 Pc code page          */
  unsigned char qsys_monitor_type;      /* 000 Monitor type          */
  unsigned char qsys_reserved[3];       /* 000 RESERVED              */
}
;                                       /* 000                       */



/*********************************************************************/
/*                     Query Session Status (22)                     */
/*********************************************************************/

struct qsst_struct                      /* 000 Query Session         */
                                        /* Status structure          */
{
  unsigned char qsst_shortname;         /* 000 Session shortname     */
  unsigned char qsst_longname[8];       /* 000 Session longname      */
  unsigned char qsst_sestype;           /* 000 Session type          */
  unsigned char qsst_char;              /* 000 Session               */
                                        /* characteristics           */
  unsigned short int qsst_ps_rows;      /* 000 Number of rows in     */
                                        /* presentation space        */
  unsigned short int qsst_ps_cols;      /* 000 Number of columns     */
                                        /* in presentation space     */
  unsigned short int qsst_host_nls;     /* 000 Host code page        */
  unsigned char qsst_reserv18;          /* 000 Reserved byte         */
}
;                                       /* 000                       */


/*********************************************************************/
/*                     Start Host Notification (23)                  */
/*********************************************************************/

struct sthn_struct                      /* 000 Start Host            */
                                        /* Notification              */
                                        /* structure.                */
{
  unsigned char sthn_shortname;         /* 000 Session Shortname     */
  unsigned char sthn_event_opt;         /* 000 Update event          */
                                        /* option                    */
  unsigned char far* sthn_asem;         /* 000 4 byte pointer to     */
  unsigned char sthn_aevent_opt;        /* 000 Async update event    */
                                        /* option                    */
}
;                                       /* 000                       */




/*********************************************************************/
/*                     Start Close Click Intercept (41)              */
/*********************************************************************/

struct stci_struct
{
  unsigned char stci_shortname;         /* 000 Session Shortname     */
  unsigned char far* stci_asem;         /* 000 4 byte pointer to     */
                                        /* 000 Async semaphore       */
}
;


/*********************************************************************/
/*                     Query Close Click Intercept (42)              */
/*********************************************************************/

struct qyci_struct
{
  unsigned char qyci_shortname;         /* 000 Session Shortname     */
}
;

/*********************************************************************/
/*                     Stop  Close Click Intercept (43)              */
/*********************************************************************/

struct spci_struct
{
  unsigned char spci_shortname;         /* 000 Session Shortname     */
}
;

/*********************************************************************/
/*                     Start Keystroke Intercept (50)                */
/*********************************************************************/

struct stki_struct                      /* 000 Start Keystroke       */
                                        /* Intercept structure       */
{
  unsigned char stki_shortname;         /* 000 Session Shortname     */
  unsigned char stki_keytyp_opt;        /* 000 Type of keys to       */
                                        /* intercept                 */
}
;                                       /* 000                       */



/*********************************************************************/
/*                     Get Key (51)                                  */
/*********************************************************************/

struct gkey_struct                      /* 000 Get Key structure.    */
{
  unsigned char gkey_shortname;         /* 000 Session Shortname     */
  unsigned char gkey_keytype;           /* 000 Type of key           */
                                        /* intercepted               */
  unsigned char gkey_key[6];            /* 000 Ascii or ascii        */
                                        /* mnemonic                  */
}
;                                       /* 000                       */



/*********************************************************************/
/*                     Post Intercept Status (52)                    */
/*********************************************************************/

struct pist_struct                      /* 000 Post Intercept        */
                                        /* Status structure          */
{
  unsigned char pist_shortname;         /* 000 Session Shortname     */
  unsigned char pist_post_opt;          /* 000 Key accepted or       */
                                        /* rejected                  */
}
;                                       /* 000                       */




/*********************************************************************/
/*                     Convert Position or Row Column (99)           */
/*********************************************************************/

struct cvrc_struct                      /* 000 Convert Position      */
                                        /* or Row Column             */
                                        /* structure                 */
{
  unsigned char cvrc_shortname;         /* 000 Session Shortname     */
  unsigned char cvrc_opt;               /* 000 Convert option        */
}
;                                       /* 000                       */



/*********************************************************************/
/*                     Connect for PM Services (101)                 */
/*********************************************************************/

struct stpm_struct                      /* 000 Connect For           */
                                        /* Presentation Manager      */
                                        /* Services structure        */
{
  unsigned char stpm_shortname;         /* 000 Session Shortname     */
}
;

/*********************************************************************/
/*                     Disconnect from PM Services (102)             */
/*********************************************************************/

struct sppm_struct                      /* 000 Disconnect From       */
                                        /* Presentation Manager      */
                                        /* Services structure        */
{
  unsigned char sppm_shortname;         /* 000 Session Shortname     */
}
;

/*********************************************************************/
/*                       Query PM Window Coordinates (103)           */
/*********************************************************************/

struct gcor_struct                      /* 000 Query PM Window       */
                                        /* Coordinates structure     */
{
  unsigned char gcor_shortname;         /* 000 Session Shortname     */
  unsigned long int gcor_xLeft;         /* 000 Left X coordinate     */
  unsigned long int gcor_yBottom;       /* 000 Bottom Y coordinate   */
  unsigned long int gcor_xRight;        /* 000 Right X coordinate    */
  unsigned long int gcor_yTop;          /* 000 Top Y coordinate      */
}
;

/*********************************************************************/
/*                       PM Window Status (104)                      */
/*********************************************************************/

struct cwin_struct                      /* 000 PM Window Status      */
                                        /* structure                 */
{
  unsigned char cwin_shortname;         /* 000 Session Shortname     */
  unsigned char cwin_option;            /* 000 Set/Query option      */
  unsigned short int cwin_flags;        /* 000 Window flags          */
  short int cwin_xpos;                  /* 000 X coordinate position */
  short int cwin_ypos;                  /* 000 Y coordinate position */
  short int cwin_xsize;                 /* 000 X axis window size    */
  short int cwin_ysize;                 /* 000 Y axis window size    */
  unsigned long int cwin_behind;        /* 000 Relative Window       */
                                        /*     placement             */
}
;


/*********************************************************************/
/*                Change Switch List Name (105)                      */
/*********************************************************************/

struct chsw_struct                      /* 000 Change Switch List    */
                                        /* Name structure            */
{
  unsigned char chsw_shortname;         /* 000 Session Shortname     */
  unsigned char chsw_option;            /* 000 Set/Reset option      */
  unsigned char chsw_swname[61];        /* 000 Switch List name      */

}
;

/*********************************************************************/
/*                Change LT Window Name (106)                        */
/*********************************************************************/

struct chlt_struct                      /* 000 Change LT Window      */
{                                       /* Name structure            */

  unsigned char chlt_shortname;         /* 000 Session Shortname     */
  unsigned char chlt_option;            /* 000 Set/Reset option      */
  unsigned char chlt_ltname[61];        /* 000 LT Window Name        */
}
;

/*ENDCDE                                                             */
